diff -ruN ../nakedmudv3.1/src/Makefile src/Makefile
--- ../nakedmudv3.1/src/Makefile	Sun Dec  4 20:18:15 2005
+++ src/Makefile	Sat Jul  1 20:11:53 2006
@@ -38,11 +38,9 @@
 LIBS    := -lz -lpthread -lcrypt
 
 # each module will add to this from its module.mk file
-SRC     := gameloop.c mud.c utils.c interpret.c handler.c inform.c movement.c \
+SRC     := gameloop.c mud.c utils.c interpret.c handler.c inform.c \
 	   action.c mccp.c save.c socket.c io.c strings.c event.c \
 	   \
-	   cmd_comm.c cmd_manip.c cmd_misc.c cmd_admin.c cmd_builder.c \
-	   \
 	   races.c \
 	   \
 	   log.c auxiliary.c account_handler.c char_gen.c \
@@ -53,6 +51,7 @@
 	   list.c property_table.c hashtable.c map.c storage.c set.c \
 	   buffer.c bitvector.c numbers.c prototype.c hooks.c parse.c \
 	   near_map.c command.c
+
 
 
 # include the description for each module. These will add to SRC
diff -ruN ../nakedmudv3.1/src/account_handler.c src/account_handler.c
--- ../nakedmudv3.1/src/account_handler.c	Sun Dec  4 20:03:08 2005
+++ src/account_handler.c	Sat Jul  1 20:06:58 2006
@@ -191,7 +191,8 @@
     // is already created, we're just editing the password. So save changes.
     if(!account_exists(accountGetName(socketGetAccount(sock)))) {
       // run hooks for creating our account for the first time
-      hookRun("create_account", socketGetAccount(sock));
+      hookRun("create_account", 
+	      hookBuildInfo("str", accountGetName(socketGetAccount(sock))));
       register_account(socketGetAccount(sock));
     }
     else
@@ -261,7 +262,7 @@
 	look_at_room(ch, charGetRoom(ch));
 
 	// run entrance hooks
-	hookRun("enter", ch, charGetRoom(ch));
+	hookRun("enter", hookBuildInfo("ch rm", ch, charGetRoom(ch)));
       }
       else {
 	text_to_buffer(sock, "There was a problem entering the game. Try again later!\r\n");
diff -ruN ../nakedmudv3.1/src/action.c src/action.c
--- ../nakedmudv3.1/src/action.c	Sun Dec  4 20:03:08 2005
+++ src/action.c	Sat Jul  1 20:06:58 2006
@@ -112,6 +112,13 @@
 #endif
 }
 
+// allows stop_all_actions to run as a hook
+void stop_actions_hook(const char *info) {
+  CHAR_DATA *ch = NULL;
+  hookParseInfo(info, &ch);
+  stop_all_actions(ch);
+}
+
 
 
 //*****************************************************************************
@@ -126,7 +133,7 @@
 	  "admin", TRUE, FALSE);
 
   // make sure the character does not continue actions after being extracted
-  hookAdd("char_from_game", stop_all_actions);
+  hookAdd("char_from_game", stop_actions_hook);
 }
 
 bool is_acting(void *ch, bitvector_t where) {
diff -ruN ../nakedmudv3.1/src/char_gen.c src/char_gen.c
--- ../nakedmudv3.1/src/char_gen.c	Sun Dec  4 20:03:07 2005
+++ src/char_gen.c	Sat Jul  1 20:06:58 2006
@@ -169,7 +169,7 @@
     look_at_room(socketGetChar(sock), charGetRoom(socketGetChar(sock)));
 
     // run any hooks for creating the player for the first time
-    hookRun("create_player", socketGetChar(sock));
+    hookRun("create_player", hookBuildInfo("ch", socketGetChar(sock)));
     
     // and register him as a valid player
     register_player(socketGetChar(sock));
@@ -183,7 +183,7 @@
 
     // run entrance hooks
     ROOM_DATA      *room = charGetRoom(socketGetChar(sock));
-    hookRun("enter", socketGetChar(sock), room);
+    hookRun("enter", hookBuildInfo("ch rm", socketGetChar(sock), room));
   }
 }
 
diff -ruN ../nakedmudv3.1/src/character.c src/character.c
--- ../nakedmudv3.1/src/character.c	Sun Dec  4 20:03:07 2005
+++ src/character.c	Sat Jul  1 20:06:58 2006
@@ -103,6 +103,7 @@
   ROOM_DATA            * last_room;
   OBJ_DATA             * furniture;
   BUFFER               * desc;
+  BUFFER               * look_buf;
   char                 * name;
   int                    sex;
   int                    position;
@@ -133,6 +134,7 @@
   ch->furniture     = NULL;
   ch->socket        = NULL;
   ch->desc          = newBuffer(1);
+  ch->look_buf      = newBuffer(1);
   ch->name          = strdup("");
   ch->sex           = SEX_NEUTRAL;
   ch->position      = POS_STANDING;
@@ -228,6 +230,10 @@
   return ch->desc;
 }
 
+BUFFER      *charGetLookBuffer( CHAR_DATA *ch) {
+  return ch->look_buf;
+}
+
 const char  *charGetRdesc     ( CHAR_DATA *ch) {
   return ch->rdesc;
 }
@@ -377,6 +383,7 @@
   if(mob->prototypes)  free(mob->prototypes);
   if(mob->name)        free(mob->name);
   if(mob->desc)        deleteBuffer(mob->desc);
+  if(mob->look_buf)    deleteBuffer(mob->look_buf);
   if(mob->rdesc)       free(mob->rdesc);
   if(mob->multi_rdesc) free(mob->multi_rdesc);
   if(mob->multi_name)  free(mob->multi_name);
diff -ruN ../nakedmudv3.1/src/character.h src/character.h
--- ../nakedmudv3.1/src/character.h	Sun Dec  4 20:03:07 2005
+++ src/character.h	Sat Jul  1 20:06:58 2006
@@ -82,6 +82,7 @@
 int          charGetSex       (CHAR_DATA *ch);
 // for editing with the text editor
 BUFFER      *charGetDescBuffer(CHAR_DATA *ch);
+BUFFER      *charGetLookBuffer(CHAR_DATA *ch);
 LIST        *charGetInventory (CHAR_DATA *ch);
 BODY_DATA   *charGetBody      (CHAR_DATA *ch);
 const char  *charGetRace      (CHAR_DATA *ch);
diff -ruN ../nakedmudv3.1/src/commands.h src/commands.h
--- ../nakedmudv3.1/src/commands.h	Sun Dec  4 20:03:07 2005
+++ src/commands.h	Sat Jul  1 20:06:58 2006
@@ -4,91 +4,16 @@
 //
 // commands.h
 //
-// contains a list of all commands available on the MUD.
+// contains a list of all commands available on the MUD. This is rather skimpy
+// since so many things were rewritten in Python.
 //
 //*****************************************************************************
 
-/* cmd_admin.c */
-COMMAND(cmd_goto);
-COMMAND(cmd_transfer);
-COMMAND(cmd_copyover);
-COMMAND(cmd_shutdown);
-COMMAND(cmd_linkdead);
-COMMAND(cmd_repeat);
-COMMAND(cmd_at);
-COMMAND(cmd_lockdown);
-COMMAND(cmd_force);
-COMMAND(cmd_pulserate);
-
-
-/* cmd_builder.c */
-COMMAND(cmd_load);
-COMMAND(cmd_purge);
-COMMAND(cmd_zreset);
-COMMAND(cmd_rlist);
-COMMAND(cmd_mlist);
-COMMAND(cmd_olist);
-COMMAND(cmd_zlist);
-COMMAND(cmd_rdelete);
-COMMAND(cmd_mdelete);
-COMMAND(cmd_odelete);
-COMMAND(cmd_mrename);
-COMMAND(cmd_rrename);
-COMMAND(cmd_orename);
-COMMAND(cmd_rreload);
-
-
-/* cmd_manip.c */
-COMMAND(cmd_unlock);
-COMMAND(cmd_lock);
-COMMAND(cmd_put);
-COMMAND(cmd_get);
-COMMAND(cmd_drop);
-COMMAND(cmd_wear);
-COMMAND(cmd_remove);
-COMMAND(cmd_give);
-COMMAND(cmd_close);
-COMMAND(cmd_open);
-
-
-/* cmd_comm.c */
-COMMAND(cmd_ask);
-COMMAND(cmd_tell);
-COMMAND(cmd_greet);
-COMMAND(cmd_say);
-COMMAND(cmd_chat);
-COMMAND(cmd_emote);
-COMMAND(cmd_gemote);
-COMMAND(cmd_page);
-
-
-/* cmd_misc.c */
-COMMAND(cmd_delay);
-COMMAND(cmd_clear);
-COMMAND(cmd_quit);
-COMMAND(cmd_save);
 COMMAND(cmd_commands);
 COMMAND(cmd_compress);
-COMMAND(cmd_motd);
-
-
-/* inform.c */
-COMMAND(cmd_who);
 COMMAND(cmd_look);
-COMMAND(cmd_inventory);
-COMMAND(cmd_equipment);
 COMMAND(cmd_groupcmds);
 COMMAND(cmd_more);
 COMMAND(cmd_back);
-COMMAND(cmd_stop);
-
-
-/* movement.c */
-COMMAND(cmd_move);
-COMMAND(cmd_sit);
-COMMAND(cmd_stand);
-COMMAND(cmd_wake);
-COMMAND(cmd_sleep);
-COMMAND(cmd_enter);
 
 #endif // __COMMAND_H
diff -ruN ../nakedmudv3.1/src/event.c src/event.c
--- ../nakedmudv3.1/src/event.c	Sun Dec  4 20:03:07 2005
+++ src/event.c	Sat Jul  1 20:06:58 2006
@@ -96,6 +96,24 @@
     event->on_complete(event->owner, event->data, event->arg);
 }
 
+void interrupt_events_obj_hook(const char *info) {
+  OBJ_DATA *obj = NULL;
+  hookParseInfo(info, &obj);
+  interrupt_events_involving(obj);
+}
+
+void interrupt_events_char_hook(const char *info) {
+  CHAR_DATA *ch = NULL;
+  hookParseInfo(info, &ch);
+  interrupt_events_involving(ch);
+}
+
+void interrupt_events_room_hook(const char *info) {
+  ROOM_DATA *room = NULL;
+  hookParseInfo(info, &room);
+  interrupt_events_involving(room);
+}
+
 
 
 //*****************************************************************************
@@ -110,9 +128,9 @@
 
   // make sure all events involving the object/char are cancelled when
   // either is extracted from the game
-  hookAdd("obj_from_game",  interrupt_events_involving);
-  hookAdd("char_from_game", interrupt_events_involving);
-  hookAdd("room_from_game", interrupt_events_involving);
+  hookAdd("obj_from_game",  interrupt_events_obj_hook);
+  hookAdd("char_from_game", interrupt_events_char_hook);
+  hookAdd("room_from_game", interrupt_events_room_hook);
 }
 
 void interrupt_event(EVENT_DATA *event) {
diff -ruN ../nakedmudv3.1/src/gameloop.c src/gameloop.c
--- ../nakedmudv3.1/src/gameloop.c	Sun Dec  4 20:03:07 2005
+++ src/gameloop.c	Sat Jul  1 20:06:58 2006
@@ -303,7 +303,7 @@
   game_loop(control);
 
   // run our finalize hooks
-  hookRun("shutdown");
+  hookRun("shutdown", "");
 
   // close down the socket
   close(control);
diff -ruN ../nakedmudv3.1/src/handler.c src/handler.c
--- ../nakedmudv3.1/src/handler.c	Sun Dec  4 20:03:07 2005
+++ src/handler.c	Sat Jul  1 20:06:58 2006
@@ -29,6 +29,8 @@
 #include "items/items.h"
 #include "items/container.h"
 #include "items/worn.h"
+#include "scripts/scripts.h"
+#include "scripts/pymud.h"
 
 
 
@@ -44,7 +46,7 @@
   propertyTablePut(obj_table, obj);
 
   // execute all of our to_game hooks
-  hookRun("obj_to_game", obj);
+  hookRun("obj_to_game", hookBuildInfo("obj", obj));
 
   // also add all contents
   if(listSize(objGetContents(obj)) > 0) {
@@ -61,7 +63,7 @@
   propertyTablePut(room_table, room);
 
   // execute all of our to_game hooks
-  hookRun("room_to_game", room);
+  hookRun("room_to_game", hookBuildInfo("rm", room));
 
   // add contents
   if(listSize(roomGetContents(room)) > 0) {
@@ -87,9 +89,9 @@
   char           *dir = NULL;
   ITERATE_LIST(dir, ex_i) {
     exit_to_game(roomGetExit(room, dir));
-    if(dirGetNum(dir) == DIR_NONE)
+    if(get_cmd_move() != NULL && dirGetNum(dir) == DIR_NONE)
       nearMapPut(roomGetCmdTable(room), dir, NULL,
-		 newCmd(dir, cmd_move, POS_STANDING, POS_FLYING,
+		 newPyCmd(dir, get_cmd_move(), POS_STANDING, POS_FLYING,
 			"player", TRUE, TRUE));
   } deleteListIterator(ex_i);
   deleteListWith(ex_list, free);
@@ -100,7 +102,7 @@
   propertyTablePut(mob_table, ch);
 
   // execute all of our to_game hooks
-  hookRun("char_to_game", ch);
+  hookRun("char_to_game", hookBuildInfo("ch", ch));
 
   // also add inventory
   if(listSize(charGetInventory(ch)) > 0) {
@@ -128,12 +130,12 @@
 }
 
 void obj_from_game(OBJ_DATA *obj) {
+  // go through all of our fromgame hooks
+  hookRun("obj_from_game", hookBuildInfo("obj", obj));
+
   listRemove(object_list, obj);
   propertyTableRemove(obj_table, objGetUID(obj));
 
-  // go through all of our fromgame hooks
-  hookRun("obj_from_game", obj);
-
   // also remove everything that is contained within the object
   if(listSize(objGetContents(obj)) > 0) {
     LIST_ITERATOR *cont_i = newListIterator(objGetContents(obj));
@@ -145,12 +147,12 @@
 }
 
 void room_from_game(ROOM_DATA *room) {
+  // go through all of our fromgame hooks
+  hookRun("room_from_game", hookBuildInfo("rm", room));
+
   listRemove(room_list, room);
   propertyTableRemove(room_table, roomGetUID(room));
 
-  // go through all of our fromgame hooks
-  hookRun("room_from_game", room);
-
   // also remove all the objects contained within the room
   if(listSize(roomGetContents(room)) > 0) {
     LIST_ITERATOR *cont_i = newListIterator(roomGetContents(room));
@@ -180,12 +182,12 @@
 }
 
 void char_from_game(CHAR_DATA *ch) {
+  // go through all of our fromgame hooks
+  hookRun("char_from_game", hookBuildInfo("ch", ch));
+
   listRemove(mobile_list, ch);
   propertyTableRemove(mob_table, charGetUID(ch));
 
-  // go through all of our fromgame hooks
-  hookRun("char_from_game", ch);
-
   // also remove inventory
   if(listSize(charGetInventory(ch)) > 0) {
     LIST_ITERATOR *inv_i = newListIterator(charGetInventory(ch));
@@ -273,106 +275,6 @@
 
 
 //*****************************************************************************
-// do_get/give/drop/etc...
-//*****************************************************************************
-void do_get(CHAR_DATA *ch, OBJ_DATA *obj, OBJ_DATA *container) {
-  if(bitIsOneSet(objGetBits(obj), "notake"))
-    send_to_char(ch, "You cannot take %s.\r\n", objGetName(obj));
-  else if(container) {
-    send_to_char(ch, "You get %s from %s.\r\n", 
-		 objGetName(obj), objGetName(container));
-    message(ch, NULL, obj, container, TRUE, TO_ROOM,
-	    "$n gets $o from $O.");
-    obj_from_obj(obj);
-    obj_to_char(obj, ch);
-  }
-  else {
-    send_to_char(ch, "You get %s.\r\n", objGetName(obj));
-    message(ch, NULL, obj, NULL, TRUE, TO_ROOM,
-	    "$n gets $o.");
-    obj_from_room(obj);
-    obj_to_char(obj, ch);
-    hookRun("get", ch, obj);
-  }
-}
-
-void do_put(CHAR_DATA *ch, OBJ_DATA *obj, OBJ_DATA *container) {
-  if(containerIsClosed(container))
-    send_to_char(ch, "%s is closed. Open it first.\r\n", 
-		 see_obj_as(ch, container));
-  else if(obj == container)
-    send_to_char(ch, "You cannot put %s into itself.\r\n", objGetName(obj));
-  // make sure we have enough room
-  else if(objGetWeight(obj) > 
-	  (containerGetCapacity(container) - 
-	   objGetWeight(container) + objGetWeightRaw(container)))
-    send_to_char(ch, "There is not enough room in %s for %s.\r\n", 
-		 see_obj_as(ch, container), see_obj_as(ch, obj));
-  // do the move
-  else {
-    obj_from_char(obj);
-    obj_to_obj(obj, container);
-    send_to_char(ch, "You put %s into %s.\r\n", 
-		 see_obj_as(ch, obj), see_obj_as(ch, container));
-    message(ch, NULL, obj, container, TRUE, TO_ROOM,
-	    "$n puts $o into $O.");
-  }
-}
-
-
-void do_give(CHAR_DATA *ch, CHAR_DATA *recv, OBJ_DATA *obj) {
-  message(ch, recv, obj, NULL, TRUE, TO_ROOM, "$n gives $o to $N.");
-  message(ch, recv, obj, NULL, TRUE, TO_VICT, "$n gives $o to you.");
-  message(ch, recv, obj, NULL, TRUE, TO_CHAR, "You give $o to $N.");
-  obj_from_char(obj);
-  obj_to_char(obj, recv);
-
-  // run all of our give/receive hooks
-  hookRun("give", ch, recv, obj);
-}
-
-
-void do_drop(CHAR_DATA *ch, OBJ_DATA *obj) {
-  send_to_char(ch, "You drop %s.\r\n", objGetName(obj));
-  message(ch, NULL, obj, NULL, TRUE, TO_ROOM, "$n drops $o.");
-  obj_from_char(obj);
-  obj_to_room(obj, charGetRoom(ch));
-
-  // run all of our drop hooks
-  hookRun("drop", ch, obj);
-}
-
-
-void do_wear(CHAR_DATA *ch, OBJ_DATA *obj, const char *where) {
-  if(!objIsType(obj, "worn"))
-    send_to_char(ch, "You cannot wear %s!\r\n", objGetName(obj));
-  else {
-    obj_from_char(obj);
-    if(try_equip(ch, obj, where, wornGetPositions(obj))) {
-      message(ch, NULL, obj, NULL, TRUE, TO_CHAR, "You equip $o.");
-      message(ch, NULL, obj, NULL, TRUE, TO_ROOM, "$n equips $o.");
-    }
-    else {
-      send_to_char(ch, "You could not equip %s.\r\n", objGetName(obj));
-      obj_to_char(obj, ch);
-    }
-  }
-}
-
-
-void do_remove(CHAR_DATA *ch, OBJ_DATA *obj) {
-  if(try_unequip(ch, obj)) {
-    message(ch, NULL, obj, NULL, TRUE, TO_CHAR, "You remove $o.");
-    message(ch, NULL, obj, NULL, TRUE, TO_ROOM, "$n removes $o.");
-    obj_to_char(obj, ch);
-  }
-  else
-    send_to_char(ch, "You were unable to remove %s.\r\n", objGetName(obj));
-}
-
-
-
-//*****************************************************************************
 // functions related to equipping and unequipping items
 //*****************************************************************************
 bool try_equip(CHAR_DATA *ch, OBJ_DATA *obj, const char *wanted_pos,
@@ -428,17 +330,14 @@
       success = bodyEquipPosnames(charGetBody(ch), obj, wanted_pos);
   }
 
-  if(success == TRUE) {
+  if(success == TRUE)
     objSetWearer(obj, ch);
-    hookRun("wear", ch, obj);
-  }
   return success;
 }
 
 bool try_unequip(CHAR_DATA *ch, OBJ_DATA *obj) {
   if(bodyUnequip(charGetBody(ch), obj)) {
     objSetWearer(obj, NULL);
-    hookRun("remove", ch, obj);
     return TRUE;
   }
   return FALSE;
@@ -453,7 +352,6 @@
   while( (obj = listPop(eq)) != NULL) {
     if(bodyUnequip(charGetBody(ch), obj)) {
       objSetWearer(obj, NULL);
-      hookRun("remove", ch, obj);
       obj_to_char(obj, ch);
     }
   } deleteList(eq);
diff -ruN ../nakedmudv3.1/src/help/help.c src/help/help.c
--- ../nakedmudv3.1/src/help/help.c	Sun Dec  4 20:03:07 2005
+++ src/help/help.c	Sat Jul  1 20:06:58 2006
@@ -39,18 +39,22 @@
   char *info;       // the information in the helpfile
   char *editor;     // who edited the helpfile?
   char *timestamp;  // when was it last edited?
+  // user_group is currently unused
+  char *user_group; // the user group the helpfile belongs to, if any
   LIST *backups;    // a chronologically sorted list of backup helps
 } HELP_DATA;
 
 
-HELP_DATA *newHelp(const char *editor, const char *timestamp,
-		   const char *keywords, const char *info) {
-  HELP_DATA *data = malloc(sizeof(HELP_DATA));
-  data->keywords  = strdupsafe(keywords);
-  data->editor    = strdupsafe(editor);
-  data->info      = strdupsafe(info);
-  data->timestamp = strdupsafe(timestamp);
-  data->backups   = newList();
+HELP_DATA *newHelp(const char *editor, const char *timestamp, 
+		   const char *keywords, const char *user_group, 
+		   const char *info) {
+  HELP_DATA *data   = malloc(sizeof(HELP_DATA));
+  data->keywords    = strdupsafe(keywords);
+  data->editor      = strdupsafe(editor);
+  data->info        = strdupsafe(info);
+  data->timestamp   = strdupsafe(timestamp);
+  data->user_group  = strdupsafe(user_group);
+  data->backups     = newList();
   return data;
 }
 
@@ -59,6 +63,7 @@
   if(data->keywords)  free(data->keywords);
   if(data->editor)    free(data->editor);
   if(data->timestamp) free(data->timestamp);
+  if(data->user_group)free(data->user_group);
   if(data->info)      free(data->info);
   free(data);
 }
@@ -67,6 +72,7 @@
   HELP_DATA *data = newHelp(read_string(set, "editor"),
 			    read_string(set, "timestamp"),
 			    read_string(set, "keywords"),
+			    read_string(set, "user_group"),
 			    read_string(set, "info"));
   deleteList(data->backups);
   data->backups = gen_read_list(read_list(set, "backups"), helpRead);
@@ -78,6 +84,7 @@
   store_string(set, "keywords",  help->keywords);
   store_string(set, "editor",    help->editor);
   store_string(set, "timestamp", help->timestamp);
+  store_string(set, "user_group",help->user_group);
   store_string(set, "info",      help->info);
   store_list  (set, "backups",   gen_store_list(help->backups, helpStore));
   return set;
@@ -238,6 +245,15 @@
 //   help <topic>
 //
 COMMAND(cmd_help) {
+  // make sure we can view it, first
+  HELP_DATA *help = get_help_data(arg, TRUE);
+  if(help != NULL && *help->user_group) {
+    if(!bitIsSet(charGetUserGroups(ch), help->user_group)) {
+      send_to_char(ch, "You may not view that help file.\r\n");
+      return;
+    }
+  }
+
   BUFFER *buf = build_help(arg);
   if(buf == NULL)
     send_to_char(ch, "No help exists on that topic.\r\n");
@@ -486,7 +502,7 @@
 
   if(data != NULL) {
     HELP_DATA *help_old = newHelp(data->editor, data->timestamp, data->keywords,
-				  data->info);
+				  "", data->info);
     if(data->editor)    free(data->editor);
     if(data->timestamp) free(data->timestamp);
     if(data->info)      free(data->info);
@@ -498,7 +514,7 @@
     listPut(data->backups, help_old);
   }
   else
-    add_help(newHelp(editor, get_time(), keyword, info));
+    add_help(newHelp(editor, get_time(), keyword, "", info));
 
   save_help();
 }
diff -ruN ../nakedmudv3.1/src/hooks.c src/hooks.c
--- ../nakedmudv3.1/src/hooks.c	Sun Dec  4 20:03:07 2005
+++ src/hooks.c	Sat Jul  1 20:06:58 2006
@@ -19,6 +19,11 @@
 //*****************************************************************************
 #include "mud.h"
 #include "utils.h"
+#include "character.h"
+#include "object.h"
+#include "room.h"
+#include "exit.h"
+#include "account.h"
 #include "hooks.h"
 
 
@@ -28,10 +33,13 @@
 //*****************************************************************************
 
 // the table of all our installed hooks
-HASHTABLE *hook_table = NULL;
+HASHTABLE *hook_table   = NULL;
 
-// a table of all our handlers for running hooks
-HASHTABLE *hook_handler_table = NULL;
+// the list of functions called whenever a hook is run
+LIST *monitors = NULL;
+
+// a buffer for building hook info on
+BUFFER      *info_buf = NULL;
 
 
 
@@ -39,141 +47,181 @@
 // implementation of hooks.h
 //*****************************************************************************
 void init_hooks(void) {
-  // make our required tables
-  hook_handler_table = newHashtable();
-  hook_table         = newHashtable();
-
-  // set up our basic types of hooks
-  hook_add_handler("shutdown",             hook_handler_0_args);
-  hook_add_handler("create_account",       hook_handler_1_arg);
-  hook_add_handler("create_player",        hook_handler_1_arg);
-  hook_add_handler("enter",                hook_handler_2_args);
-  hook_add_handler("exit",                 hook_handler_3_args);
-  hook_add_handler("ask",                  hook_handler_3_args);
-  hook_add_handler("say",                  hook_handler_2_args);
-  hook_add_handler("greet",                hook_handler_2_args);
-  hook_add_handler("obj_to_game",          hook_handler_1_arg);
-  hook_add_handler("char_to_game",         hook_handler_1_arg);
-  hook_add_handler("room_to_game",         hook_handler_1_arg);
-  hook_add_handler("obj_from_game",        hook_handler_1_arg);
-  hook_add_handler("char_from_game",       hook_handler_1_arg);
-  hook_add_handler("room_from_game",       hook_handler_1_arg);
-  hook_add_handler("get",                  hook_handler_2_args);
-  hook_add_handler("give",                 hook_handler_3_args);
-  hook_add_handler("drop",                 hook_handler_2_args);
-  hook_add_handler("wear",                 hook_handler_2_args);
-  hook_add_handler("remove",               hook_handler_2_args);
-  hook_add_handler("reset",                hook_handler_1_arg);
-  hook_add_handler("open_door",            hook_handler_2_args);
-  hook_add_handler("open_obj",             hook_handler_2_args);
-  hook_add_handler("close_door",           hook_handler_2_args);
-  hook_add_handler("close_obj",            hook_handler_2_args);
-}
-
-void hook_add_handler(const char *type, 
-		      void (* handler)(LIST *hooks, va_list args)) {
-  hashPut(hook_handler_table, type, handler);
+  // make our required variables
+  hook_table = newHashtable();
+  info_buf   = newBuffer(1);
+  monitors   = newList();
 }
 
-void hookAdd(const char *type, void *hook) {
+void hookRemove(const char *type, void (* func)(const char *)) {
+  LIST *list = hashGet(hook_table, type);
+  if(list != NULL) listRemove(list, func);
+}
+
+void hookAdd(const char *type, void (* func)(const char *)) {
   LIST *list = hashGet(hook_table, type);
   if(list == NULL) {
     list = newList();
     hashPut(hook_table, type, list);
   }
-  listQueue(list, hook);
+  listQueue(list, func);
 }
 
-void hookRun(const char *type, ...) {
-  LIST *list = hashGet(hook_table, type);
-  void (* handler)(LIST *hooks, va_list args) = 
-    hashGet(hook_handler_table, type);
-  if(list != NULL && handler != NULL) {
-    va_list args;
-    va_start(args, type);
-    handler(list, args);
-    va_end(args);
-  }
+void hookAddMonitor(void (* func)(const char *, const char *)) {
+  listQueue(monitors, func);
 }
 
-void hookRemove(const char *type, void *hook) {
+void hookRun(const char *type, const char *info) {
   LIST *list = hashGet(hook_table, type);
-  if(list != NULL) listRemove(list, hook);
+  if(list != NULL) {
+    char *info_dup = strdup(info);
+    LIST_ITERATOR *list_i = newListIterator(list);
+    void (* func)(const char *) = NULL;
+    ITERATE_LIST(func, list_i) {
+      func(info_dup);
+    } deleteListIterator(list_i);
+    free(info_dup);
+  }
+
+  // run our monitors
+  LIST_ITERATOR *mon_i = newListIterator(monitors);
+  void (* mon)(const char *, const char *) = NULL;
+  ITERATE_LIST(mon, mon_i) {
+    mon(type, info);
+  } deleteListIterator(mon_i);
+}
+
+const char *hookBuildInfo(const char *format, ...) {
+  // clear our workspace
+  bufferClear(info_buf);
+
+  // parse out all of our tokens
+  LIST *tokens           = parse_strings(format, ' ');
+  LIST_ITERATOR *token_i = newListIterator(tokens);
+  char *token            = NULL;
+  int   len              = listSize(tokens);
+  int   count            = 0;
+
+  // go through all of our tokens
+  va_list vargs;
+  va_start(vargs, format);
+  ITERATE_LIST(token, token_i) {
+    if(!strcasecmp(token, "ch"))
+      bprintf(info_buf, "ch.%d", charGetUID(va_arg(vargs, CHAR_DATA *)));
+    else if(!strcasecmp(token, "obj"))
+      bprintf(info_buf, "obj.%d", objGetUID(va_arg(vargs, OBJ_DATA *)));
+    else if(!strcasecmp(token, "rm") || !strcasecmp(token, "room"))
+      bprintf(info_buf, "rm.%d", roomGetUID(va_arg(vargs, ROOM_DATA *)));
+    else if(!strcasecmp(token, "ex") || !strcasecmp(token, "exit"))
+      bprintf(info_buf, "ex.%d", exitGetUID(va_arg(vargs, EXIT_DATA *)));
+    else if(!strcasecmp(token, "str"))
+      bprintf(info_buf, "%c%s%c", HOOK_STR_MARKER, va_arg(vargs, char *), HOOK_STR_MARKER);
+    else if(!strcasecmp(token, "int"))
+      bprintf(info_buf, "%d", va_arg(vargs, int));
+    else if(!strcasecmp(token, "dbl"))
+      bprintf(info_buf, "%lf", va_arg(vargs, double));
+    // unknown type -- abort!
+    else
+      break;
+
+    // add a space for the next token to be printed
+    if(count < len - 1)
+      bprintf(info_buf, " ");
+    count++;
+  } deleteListIterator(token_i);
+  deleteListWith(tokens, free);
+  va_end(vargs);
+  return bufferString(info_buf);
+}
+
+//
+// parses up info tokens
+LIST *parse_hook_info_tokens(const char *info) {
+  LIST *tokens = newList();
+  BUFFER  *buf = newBuffer(1);
+  while(*info) {
+    // skip leading spaces
+    while(isspace(*info))
+      info++;
+
+    char marker = ' ';
+    bufferClear(buf);
+    
+    // are we parsing a string or something else?
+    if(*info == HOOK_STR_MARKER) {
+      marker = HOOK_STR_MARKER;
+      bprintf(buf, "%c", HOOK_STR_MARKER);
+      info++;
+    }
+
+    // fill up to the end marker
+    for(;*info && *info != marker; info++)
+      bprintf(buf, "%c", *info);
+
+    // were we parsing a string?
+    if(marker == HOOK_STR_MARKER)
+      bprintf(buf, "%c", HOOK_STR_MARKER);
+
+    // skip past our marker
+    if(*info) info++;
+    
+    // append our token
+    listQueue(tokens, strdup(bufferString(buf)));
+  }
+  deleteBuffer(buf);
+  return tokens;
 }
 
-void hook_handler_0_args(LIST *hooks, va_list args) {
-  LIST_ITERATOR *hook_i = newListIterator(hooks);
-  void   (* hook)(void) = NULL;
-  ITERATE_LIST(hook, hook_i) {
-    hook();
-  } deleteListIterator(hook_i);
-}
-
-void hook_handler_1_arg(LIST *hooks, va_list args) {
-  LIST_ITERATOR *hook_i = newListIterator(hooks);
-  void *arg1 = va_arg(args, void *);
-  void (* hook)(void *) = NULL;
-  ITERATE_LIST(hook, hook_i) {
-    hook(arg1);
-  } deleteListIterator(hook_i);
-}
-
-void hook_handler_2_args(LIST *hooks, va_list args) {
-  LIST_ITERATOR *hook_i = newListIterator(hooks);
-  void *arg1 = va_arg(args, void *);
-  void *arg2 = va_arg(args, void *);
-  void (* hook)(void *, void *) = NULL;
-  ITERATE_LIST(hook, hook_i) {
-    hook(arg1, arg2);
-  } deleteListIterator(hook_i);
-}
-
-void hook_handler_3_args(LIST *hooks, va_list args) {
-  LIST_ITERATOR *hook_i = newListIterator(hooks);
-  void *arg1 = va_arg(args, void *);
-  void *arg2 = va_arg(args, void *);
-  void *arg3 = va_arg(args, void *);
-  void (* hook)(void *, void *, void *) = NULL;
-  ITERATE_LIST(hook, hook_i) {
-    hook(arg1, arg2, arg3);
-  } deleteListIterator(hook_i);
-}
-
-void hook_handler_4_args(LIST *hooks, va_list args) {
-  LIST_ITERATOR *hook_i = newListIterator(hooks);
-  void *arg1 = va_arg(args, void *);
-  void *arg2 = va_arg(args, void *);
-  void *arg3 = va_arg(args, void *);
-  void *arg4 = va_arg(args, void *);
-  void (* hook)(void *, void *, void *, void *) = NULL;
-  ITERATE_LIST(hook, hook_i) {
-    hook(arg1, arg2, arg3, arg4);
-  } deleteListIterator(hook_i);
-}
-
-void hook_handler_5_args(LIST *hooks, va_list args) {
-  LIST_ITERATOR *hook_i = newListIterator(hooks);
-  void *arg1 = va_arg(args, void *);
-  void *arg2 = va_arg(args, void *);
-  void *arg3 = va_arg(args, void *);
-  void *arg4 = va_arg(args, void *);
-  void *arg5 = va_arg(args, void *);
-  void (* hook)(void *, void *, void *, void *, void *) = NULL;
-  ITERATE_LIST(hook, hook_i) {
-    hook(arg1, arg2, arg3, arg4, arg5);
-  } deleteListIterator(hook_i);
-}
-
-void hook_handler_6_args(LIST *hooks, va_list args) {
-  LIST_ITERATOR *hook_i = newListIterator(hooks);
-  void *arg1 = va_arg(args, void *);
-  void *arg2 = va_arg(args, void *);
-  void *arg3 = va_arg(args, void *);
-  void *arg4 = va_arg(args, void *);
-  void *arg5 = va_arg(args, void *);
-  void *arg6 = va_arg(args, void *);
-  void (* hook)(void *, void *, void *, void *, void *, void *) = NULL;
-  ITERATE_LIST(hook, hook_i) {
-    hook(arg1, arg2, arg3, arg4, arg5, arg6);
-  } deleteListIterator(hook_i);
+void hookParseInfo(const char *info, ...) {
+  // parse out all of our tokens
+  LIST *tokens           = parse_hook_info_tokens(info);
+  LIST_ITERATOR *token_i = newListIterator(tokens);
+  char *token            = NULL;
+
+  // id number we'll need for parsing some values
+  int id = 0;
+
+  // go through all of our tokens
+  va_list vargs;
+  va_start(vargs, info);
+  ITERATE_LIST(token, token_i) {
+    if(startswith(token, "ch")) {
+      sscanf(token, "ch.%d", &id);
+      *va_arg(vargs, CHAR_DATA **) = propertyTableGet(mob_table, id);
+    }
+    else if(startswith(token, "obj")) {
+      sscanf(token, "obj.%d", &id);
+      *va_arg(vargs, OBJ_DATA **) = propertyTableGet(obj_table, id);
+    }
+    else if(startswith(token, "rm")) {
+      sscanf(token, "rm.%d", &id);
+      *va_arg(vargs, ROOM_DATA **) = propertyTableGet(room_table, id);
+    }
+    else if(startswith(token, "room")) {
+      sscanf(token, "room.%d", &id);
+      *va_arg(vargs, ROOM_DATA **) = propertyTableGet(room_table, id);
+    }
+    else if(startswith(token, "ex")) {
+      sscanf(token, "ex.%d", &id);
+      *va_arg(vargs, EXIT_DATA **) = propertyTableGet(exit_table, id);
+    }
+    else if(startswith(token, "exit")) {
+      sscanf(token, "exit.%d", &id);
+      *va_arg(vargs, EXIT_DATA **) = propertyTableGet(exit_table, id);
+    }
+    else if(*token == HOOK_STR_MARKER) {
+      char *str = strdup(token + 1);
+      str[strlen(str)-1] = '\0';
+      *va_arg(vargs, char **) = str;
+    }
+    else if(isdigit(*token)) {
+      // integer or double?
+      if(next_letter_in(token, '.') > -1)
+	*va_arg(vargs, double *) = atof(token);
+      else
+	*va_arg(vargs, int *) = atoi(token);
+    }
+  } deleteListIterator(token_i);
+  deleteListWith(tokens, free);
+  va_end(vargs);
 }
